local on_criminal_suspicion_progress = GroupAIStateBase.on_criminal_suspicion_progress
function GroupAIStateBase:on_criminal_suspicion_progress(u_suspect, u_observer, status)
	on_criminal_suspicion_progress(self, u_suspect, u_observer, status)
	if not self._ai_enabled or not self._whisper_mode then
		return
	end
	if LuaNetworking:IsMultiplayer() and LuaNetworking:IsClient() then return end
	local ignore_suspicion = u_observer:brain() and u_observer:brain()._ignore_suspicion
	local observer_is_dead = u_observer:character_damage() and u_observer:character_damage():dead()
	local settings = HighAlert and HighAlert.settings
	local enabled = settings and settings.Enabled == "on"
	local guardA = settings and settings.GuardMode or 1
	local guardJam = settings and settings.GuardJammable == "on"
	local civA = settings and settings.CivMode or 1
	local civJam = settings and settings.CivJammable == "on"
	local isGuard = not not managers.enemy:is_enemy(u_observer)
	local isCiv = not not managers.enemy:is_civilian(u_observer)
	local isJammed = self:is_ecm_jammer_active("call")

	if not enabled then return end
	if (((isGuard and guardJam) or (isCiv and civJam)) and isJammed) then return end
	if ignore_suspicion or observer_is_dead then return end
	if (isGuard and guardA == 1) or (isCiv and civA == 1) then
		return
	end
	local obs_key = u_observer:key()

	if managers.groupai:state():all_AI_criminals()[obs_key] or not (isCiv or isGuard) then return end
	if status == true or status == "call_interrupted" then
		if isGuard and guardA == 3 then
			managers.groupai:state():on_police_called("cop_criminal")
		elseif isCiv and civA == 3 then
			managers.groupai:state():on_police_called("civ_criminal")
		end
	elseif status == "calling" then
		if isGuard and guardA == 2 then
			managers.groupai:state():on_police_called("cop_criminal")
		elseif isCiv and civA == 2 then
			managers.groupai:state():on_police_called("civ_criminal")
		end
	elseif status == "called" then
		managers.groupai:state():on_police_called("default")
	end
end
