_G.HighAlert = _G.HighAlert or {}
HighAlert.settings = HighAlert.settings or {}
HighAlert.OptionPath = SavePath.."HighAlert_Options.txt"
HighAlert.ModPath = ModPath
function HighAlert:load()
	HighAlert.settings = {}
	local optionsFile = io.open(HighAlert.OptionPath, 'r')
	if optionsFile then
		for key, value in pairs(json.decode(optionsFile:read('*all'))) do
			HighAlert.settings[key] = value
		end
		optionsFile:close()
	else
		HighAlert:reset()
	end
end

function HighAlert:save()
	local optionsFile = io.open(HighAlert.OptionPath, 'w+')
	if optionsFile then
		optionsFile:write(json.encode(HighAlert.settings))
		optionsFile:close()
	end
end

function HighAlert:reset()
	HighAlert.settings.Enabled = true
	HighAlert.settings.Mode = 3
	HighAlert.settings.GuardMode = 2
	HighAlert.settings.GuardJammable = true
	HighAlert.settings.CivMode = 1
	HighAlert.settings.CivJammable = false
end

local function set_enabled()
	local menu = MenuHelper:GetMenu('ha_main')
	local value = menu:item("ha_mode"):value()
	local civMode = menu:item('ha_civ_mode')
	local civJam = menu:item('ha_civ_jammable')
	local guardMode = menu:item('ha_guard_mode')
	local guardJam = menu:item('ha_guard_jammable')
	if value == 2 then
		civMode:set_enabled(true)
		civJam:set_enabled(true)
		guardMode:set_enabled(true)
		guardJam:set_enabled(true)
		return
	else
		civMode:set_enabled(false)
		civJam:set_enabled(false)
		guardMode:set_enabled(false)
		guardJam:set_enabled(false)
	end
end

Hooks:Add('LocalizationManagerPostInit', 'LocalizationManagerPostInit_HighAlertDetectionIcon', function(loc)
	local language
	local ModPath = HighAlert.ModPath
	for _, filename in pairs(file.GetFiles(ModPath .. 'loc/')) do
		local str = filename:match('^(.*).txt$')
		if str and Idstring(str) and Idstring(str):key() == SystemInfo:language():key() then
			language = filename
			break
		end
	end

	if language then
		loc:load_localization_file(ModPath .. 'loc/' .. language)
	end
	loc:load_localization_file(ModPath .. 'loc/english.txt', false)
end)

Hooks:Add('MenuManagerInitialize', 'MenuManagerInitialize_HighAlert', function(menu_manager)
	MenuCallbackHandler.HAModeChanged = function(_, item)
		local menu = MenuHelper:GetMenu('ha_main')
		local value = item:value()
		local civMode = menu:item('ha_civ_mode')
		local civJam = menu:item('ha_civ_jammable')
		local guardMode = menu:item('ha_guard_mode')
		local guardJam = menu:item('ha_guard_jammable')
		set_enabled()
		if value == 1 then
			civMode:set_value(1)
			civJam:set_value("on")
			guardMode:set_value(1)
			guardJam:set_value("on")
		elseif value == 3 then
			civMode:set_value(2)
			civJam:set_value("off")
			guardMode:set_value(2)
			guardJam:set_value("on")
		elseif value == 4 then
			civMode:set_value(2)
			civJam:set_value("off")
			guardMode:set_value(3)
			guardJam:set_value("off")
		end
	end

	MenuCallbackHandler.HASaved = function()
		local menu = MenuHelper:GetMenu("ha_main")

		local enabled = menu:item('ha_enabled'):value()
		local mode = menu:item('ha_mode'):value()
		local civMode = menu:item('ha_civ_mode'):value()
		local civJam = menu:item('ha_civ_jammable'):value()
		local guardMode = menu:item('ha_guard_mode'):value()
		local guardJam = menu:item('ha_guard_jammable'):value()
		HighAlert.settings.Enabled = enabled
		HighAlert.settings.Mode = mode
		HighAlert.settings.GuardMode = guardMode
		HighAlert.settings.GuardJammable = guardJam
		HighAlert.settings.CivMode = civMode
		HighAlert.settings.CivJammable = civJam
		
		HighAlert:save()
	end

	MenuCallbackHandler.HAOpened = function(_, focus)
		if not focus then return end
		local menu = MenuHelper:GetMenu('ha_main')
		local enabled = menu:item("ha_enabled")
		local mode = menu:item("ha_mode")
		local civMode = menu:item('ha_civ_mode')
		local civJam = menu:item('ha_civ_jammable')
		local guardMode = menu:item('ha_guard_mode')
		local guardJam = menu:item('ha_guard_jammable')
		set_enabled()
		enabled:set_value(HighAlert.settings.Enabled)
		mode:set_value(HighAlert.settings.Mode)
		civMode:set_value(HighAlert.settings.CivMode)
		civJam:set_value(HighAlert.settings.CivJammable)
		guardMode:set_value(HighAlert.settings.GuardMode)
		guardJam:set_value(HighAlert.settings.GuardJammable)
	end

	HighAlert:load()
	MenuHelper:LoadFromJsonFile(HighAlert.ModPath.."options/option.txt", HighAlert, HighAlert.settings)
end)